const LEVELNAME = new Array("easy", "normal", "hard", "super");
const LEVELBALLSNB = new Array (5,7,9,10);
const LEVELSIZE = new Array (9,9,9,11);
const SUPERLIMITSCORE = 600;

const SCOREPLUS = { 	5	:	11,
							6	:	15,
							7	:	21,
							8	:	29,
							9	:	39	};

const COLOR = new Array (	'#0c0',	// green
									'#00c',	// dark blue
									'#f00',	// red
									'#fc0', // yellow
									'#000', // dark
									'#f6f', // pink
									'#808080', // gray
									'#9cc', // light blue
									'#969', // violet
									'#cc9'); // light gray

const SELECTEDCOLOR 	= "#ff6";
const RECTCOLOR		= document.getElementById("clines-box-svg").childNodes[1].childNodes[1].getAttributeNS(null, "fill");
const BGCOLOR			= document.getElementById("clines-board-background").getAttributeNS(null, "fill");

Node.prototype.setAttributes = function (list) {
	for (var attr in list)
		this.setAttributeNS(null, attr, list[attr]) }

const prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.{616f2aa8-9674-4009-90de-94ce4ea9d29a}.");
// get preferences
const	DEFAULTLEVEL		= prefs.getIntPref("level");
const	DEFAULTSHOWNEXT	= prefs.getBoolPref("shownext"); 
const	DEFAULTFACTOR 		= parseFloat(prefs.getCharPref("factor")) || 1;
const	SUPER					= prefs.getBoolPref("super"); 

function copy (matrix1) {
	var matrix2 = new Array();
	for (var i in matrix1) {
		if (matrix1[i].length !== undefined)
			matrix2.push(copy(matrix1[i]));
		else 
			matrix2.push(matrix1[i].clone()); }
	return matrix2; }

var game, grid;
const nextGrid = new NextGrid();
const board = new Board();

var level;

window.onload = function() {
	game = new Game (DEFAULTLEVEL); }

window.onunload = function () {
	prefs.setIntPref("level", level);
	prefs.setBoolPref("shownext", board.showNext); 
	prefs.setCharPref("factor", board.factor.toString()); 
	}

function Board () {
	this.container				= document.getElementById("clines-svg-space");
	this.boxContainer			= document.getElementById("clines-box-svg").childNodes[1];
	this.superMenuseparator = document.getElementById("clines-menuseparator-super");
	this.superMenuitem		= document.getElementById("clines-menu-newgame-super-radio");
	this.statusbarLevel		= document.getElementById("clines-statusbar-level");
	this.statusbarScore		= document.getElementById("clines-statusbar-score");
	this.stringBundle			= document.getElementById("clines-strings");
	this.commandUndo			= document.getElementById("clines-command-undo");
	this.commmandEndTurn		= document.getElementById("clines-command-endturn");
	this.menuitemNext			= document.getElementById("clines-menu-shownext-radio");
	this.menuitemGame			= new Array();

	this.displaySuperMenu = function () {
		this.superMenuseparator.removeAttributeNS(null, "style");
		this.superMenuitem.removeAttributeNS(null, "style"); }

	this.showNext 	= DEFAULTSHOWNEXT;
	this.factor		= DEFAULTFACTOR;
	this.superGame	= SUPER;
	var boxSize	= this.boxContainer.getAttributeNS(null, "height");
	this.menuitemNext.setAttributeNS(null, "checked", this.showNext);

	for (var i = 0; i < 3 ; i++) 
		nextGrid.matrix[i].show(this.showNext); 

	for (var levelname in LEVELNAME)
		this.menuitemGame.push(document.getElementById("clines-menu-newgame-" + LEVELNAME[levelname] + "-radio"));

	if (this.superGame)
		this.displaySuperMenu();

	this.draw = function(level) {
		var size = grid.size;
		grid.draw(boxSize);
		nextGrid.draw(boxSize, size);
		this.container.setAttributeNS(null, "viewBox" , "0 0 " + (size + 11 / 2) * boxSize + " " + (size + 1) * boxSize);
		this.disableLevelMenu(level);
		this.statusbarLevel.value = this.stringBundle.getString(LEVELNAME[level]);
		this.resize(); }

	this.blockMoveMenu = function (flag) {	// at the end of the game
		this.commandUndo.setAttributeNS(null, "disabled", flag );
		this.commmandEndTurn.setAttributeNS(null, "disabled", flag );}
		
	this.disableLevelMenu = function (level) {
		var menuitemLevel = this.menuitemGame[level];
		for (var i in this.menuitemGame) {
			var menuitem = this.menuitemGame[i];
			if (menuitemLevel == menuitem)
				menuitem.setAttributes({"checked" : "true" , "disabled" : "true"});
			else
				menuitem.setAttributes({"checked" : "false" , "disabled" : "false"}); } }

	this.resize = function() {
		var width 	= this.container.getAttributeNS(null, "viewBox").split(" ")[2];
		var height	= this.container.getAttributeNS(null, "viewBox").split(" ")[3];
		this.container.setAttributes({ 	"width"	: width * this.factor,
													"height"	: height * this.factor }) 
	sizeToContent(); 
		}

	this.zoom = function (zoom) {
		this.factor = (zoom ? this.factor * zoom : 1);
		this.resize(); }

	this.displayScore = function (score) {
		this.statusbarScore.value = score; }

   this.toggleShowNext = function () {
      this.showNext = (this.showNext ==true) ? false : true;
		for (var i = 0; i < 3 ; i++) 
			nextGrid.matrix[i].show(this.showNext); } 
	
	this.openFactor = function (uri, title, factor) {
	//if factor = 0.7 for example, window will take 70% af the screen
		var width=screen.availWidth*factor;
		var height=screen.availHeight*factor;
		window.openDialog( uri, title, "width=" + width + ",height=" + height + "modal, scrollar, resizable"); }

}

function Box (u, add, c) {

		this.setColor = function (c, flag) {
			color = c;
			use.childNodes[3].setAttributeNS(null, "fill", COLOR[c]);
			if (!flag) this.show(true); }

		this.clone = function () {
			return new Box(use.cloneNode(true), add, color) }

		this.deleteColor = function () {
			color = undefined;
			this.show(false); } 

		this.select = function () {
			use.childNodes[1].setAttributeNS(null, "fill", SELECTEDCOLOR);
			grid.oldBall = grid.matrix[use.xPos][use.yPos]; }

		this.unselect = function() {
			use.childNodes[1].setAttributeNS(null, "fill", RECTCOLOR); }

		this.removeEvent = function() {
            use.onmousedown=null;}

		this.show = function(flag) {
			var visibility = { "true" : "visible" , "false" : "hidden"}[flag];
			use.childNodes[3].setAttributeNS(null, "visibility", visibility) ;
			use.childNodes[5].setAttributeNS(null, "visibility", visibility) ; }

		this.place = function (x, y) {
		  use.setAttributes({  "x"   : x , "y"  : y }); }

		this.reset = function() {
			this.removeEvent();
			this.deleteColor(); 
            use.onmousedown=this.click;}

   	this.click = function(e) {
			if (e.button !== 0) return;
			var ball = grid.matrix[use.xPos][use.yPos];
			switch(game.mode) {
				case "toselect":
					if (color === undefined) return;
					ball.select();
					game.switchMode();
				break;

			case "toplace":
				 grid.oldBall.unselect();

				if (color !== undefined) {
					if (ball !== grid.oldBall) 
						ball.select();
					else
						game.switchMode();
					return; }

			if (!grid.thereIsAWay(new Array(new Array(grid.oldBall.x, grid.oldBall.y)), copy(grid.matrix), ball)) {
				grid.oldBall.select();
				return }

			game.save();
	       //makes the move
			 ball.setColor(grid.oldBall.color);
			 grid.oldBall.deleteColor();

			if (!game.killLine(ball))
				game.endTurn();

	       game.switchMode();
	 
		 break;

      default:
		 break;
      }
   }

		var use = u;
		var color = c;
		if (add)
            use.onmousedown=this.click;

/* WARNING: __defineGetter__ is Mozilla only ; not part of the ECMAScript standard */
this.__defineGetter__( "x", function() { return use.xPos });
this.__defineGetter__( "y", function() { return use.yPos });
this.__defineGetter__( "color", function() { return color });

}

function NextGrid () {
	this.text			= document.getElementById("clines-next-text");
	this.container		= document.getElementById("clines-next-container");
	this.cloned			= document.getElementById("clines-box-svg").childNodes[1];

	this.matrix = new Array;
	// create nextBox objects
	for (var i = 0 ; i < 3 ; i ++) {
		var use = this.cloned.cloneNode(true);
		this.matrix[i] = new Box(use);
		this.container.appendChild(use); }

	this.draw = function (boxSize, size) {
		var y = (size / 2) * boxSize;
		// place balls
		for (var i in this.matrix)
			this.matrix[i].place((size + 3/2 + parseInt(i)) * boxSize, y);
		// places text
		this.text.setAttributes({	"x"	: (size + 3)  * boxSize,
											"y" 	: (size / 2 - 1 /4) * boxSize });
		// set text size
		this.text.setAttributes({ "font-size" : boxSize * 3 / 8 }); }

	this.defineBalls = function () {
      for (var i = 0; i < 3; i++) {
			 var c = Math.floor(Math.random()*grid.colorsNumber);
			 this.matrix[i].setColor(c, !board.showNext); }}

}

function Grid (level) {
	this.cloned			= document.getElementById("clines-box-svg").childNodes[1];
	this.container 	= document.getElementById("clines-grid-container");

	this.reinitialize = function () {
		grid.oldBall.unselect();
		for (var x = 0; x < this.size; x++)
				for(var y = 0; y < this.size; y++)
					this.matrix[x][y].reset(); }

	this.draw = function(boxSize) {	// grid is created  and drawn at the same time
		for (var x = 0; x < this.size; x++) {
			this.matrix[x] = new Array(this.size);
				for(var y = 0; y < this.size; y++) {
					var use = this.cloned.cloneNode(true);
					use.xPos = x; use.yPos = y;
					use.setAttributes({	"x"	:  (x + 1 / 2) * boxSize,
												"y"	:  (y + 1 / 2) * boxSize });
					this.matrix[x][y] = new Box(use, 1);
					this.container.appendChild(use); } } }

	 this.thereIsAWay = function (table, matrix, arrivalBall) {
 		var arrivalX = arrivalBall.x;
 		var arrivalY = arrivalBall.y;
      var tab=new Array();
      for (var point in table) {
			 var x=table[point][0]; 
			 var y=table[point][1];
			 //to the right
			 if (x + 1 < this.size && matrix[x+1][y].color == undefined ) {
				 if (x + 1 == arrivalX && y == arrivalY) return 1;
				 tab.push(new Array(x+1,y));
				 matrix[x+1][y] = new Box(null, false, 1);
			 }
			 //to the left
			 if (x > 0 && matrix[x-1][y].color == undefined) {
				 if (x - 1 == arrivalX && y == arrivalY) return 1;
				 tab.push(new Array(x-1,y));
				 matrix[x-1][y] = new Box(null, false, 1);
			 }
			 //to the bottom
			 if (y + 1 < this.size && matrix[x][y+1].color == undefined) {
				 if (x == arrivalX && y + 1 == arrivalY) return 1;
				 tab.push(new Array(x,y+1));
				 matrix[x][y+1] = new Box(null, false, 1);
			 }
			 //to the top
			 if (y > 0 && matrix[x][y-1].color == undefined) {
				 if (x == arrivalX && y - 1 == arrivalY) return 1;
				 tab.push(new Array(x,y-1));
				 matrix[x][y-1] = new Box(null, false, 1);
			 }
			}
			if (tab.length == 0) return 0;
			return (this.thereIsAWay(tab, matrix, arrivalBall))
		}

	this.size = LEVELSIZE[level];
   this.colorsNumber = LEVELBALLSNB[level];
	this.maxBallsNumber = LEVELSIZE[level] * LEVELSIZE[level];

	this.matrix = new Array(length);

	// removes old grid
	while (this.container.hasChildNodes())
		this.container.removeChild(this.container.firstChild);

}

function SaveDisposition  () {
     this.score			= game.score;
     this.grid				= copy(grid.matrix);
     this.ballsNumber	= game.ballsNumber;
     this.nextBalls		= copy(nextGrid.matrix);
}

function Game (l) {

	this.endTurn = function() {
		//to avoid script to slow down Firefox
		if (ended) return;

		for (var i = 0; i < 3; i++) {	// chooses one place on the grid
			do { 	var x = Math.floor(Math.random()*grid.size);
				 	var y = Math.floor(Math.random()*grid.size);
			} while (grid.matrix[x][y].color !== undefined);

			var color = nextGrid.matrix[i].color;
			grid.matrix[x][y].setColor(color);
			this.killLine(grid.matrix[x][y]);
			if (++this.ballsNumber >= grid.maxBallsNumber) {
				 this.endGame();
				 break; } }
		nextGrid.defineBalls(); }

	this.skipTurn = function () {
		this.save();
		this.endTurn(); }
	
	this.endGame = function () { // end game
			board.blockMoveMenu(true); 
			ended=true; 
				for (var i = 0; i < grid.size; i ++) 
					for (var j = 0; j < grid.size; j ++) 
						grid.matrix[i][j].removeEvent(); 
			if (!board.superGame && this.score >= SUPERLIMITSCORE && level >= 1) { // discovering super level
				 alert(document.getElementById("clines-strings").getString("hiddengame-discover"));
				 board.displaySuperMenu(); 
				prefs.setBoolPref("super", true); } 
			if (level < 3)
				 window.openDialog('chrome://clines/content/highscores.xul','clines-highscores','chrome,modal',level,this.score) }

   this.switchMode = function (mode) {
		this.mode = mode || { 'toselect' : 'toplace', 'toplace' : 'toselect' } [this.mode]; }

   this.killLine = function (ball) {
		var x = ball.x;
		var y = ball.y;
		var color = ball.color;
		var time = 0;	// time of the settimeout for the animation
      var killed=false;
      //horizontal
      var i = x; var j = x; var k;
      while (i > 0 && grid.matrix[i-1][y].color === color)
			 i--;
      while (j < (grid.size - 1)  && grid.matrix[j+1][y].color === color)
			 j++
      if ((j-i) >= 4) {
	    killed=true;
	    this.score += SCOREPLUS[j-i+1];
	    for (k=i; k<= j; k++)
	       if (k != x)
		  this.eraseBall(k,y, ++time)
      }
      //vertical
      i=y; j=y;
      while (i > 0 && grid.matrix[x][i-1].color === color)
			 i--;
      while (j < (grid.size - 1)  && grid.matrix[x][j+1].color === color) 
			 j++
      if ((j-i) >= 4) {
	    killed=true;
	    this.score += SCOREPLUS[j-i+1];
	    for (k=i; k<= j; k++)
	       if (k != y)
		  this.eraseBall(x,k, ++time)
      }
      //first diagonal
      i=x; j=x;
      while ( i > 0 && (y - x + i) > 0 && grid.matrix[i-1][y-x+i-1].color === color) 
			 i--;
      while (j < (grid.size - 1)  && (y - x + j) < (grid.size - 1) && grid.matrix[j+1][y-x+j+1].color === color) 
			 j++;
      if ((j-i) >= 4) {
	    killed=true;
	    this.score += SCOREPLUS[j-i+1];
	    for (k=i; k<= j; k++)
	       if (k != x)
		  this.eraseBall(k,y-x+k, ++time);
      }
      //second diagonal
      i=x; j=x;
      while ( i > 0 && (y + x - i) < (grid.size - 1) && grid.matrix[i-1][y+x-i+1].color === color) 
	 i--;
      while (j < (grid.size - 1)  && (y + x - j) > 0 && grid.matrix[j+1][y+x-j-1].color === color) 
	 j++;
      if ((j-i) >= 4) {
	    killed=true;
	    this.score += SCOREPLUS[j-i+1];
	    for (k=i; k<= j; k++)
	       if (k != x)
		  this.eraseBall(k,y+x-k, ++time);
      }
      if (killed) {
			 this.eraseBall(x,y, ++time);
			board.displayScore(this.score);
      }
      return killed;
   }

	this.save = function () {
		savedGame = new SaveDisposition(); }

	this.eraseBall = function (x,y, time) {
		this.ballsNumber--;
		window.setTimeout("grid.matrix[" + x + "][" + y + "].deleteColor()", time * 150); }
		
	this.undo = function () {
      if (this.ballsNumber <= 3 || ended) return; //cannot undo before first move or after end game
		for (var i = 0; i < grid.size; i ++)
			for (var j = 0; j < grid.size; j ++) {
				var ball = savedGame.grid[i][j];
				if (grid.matrix[i][j].color !== ball.color) {
					if (ball.color === undefined) grid.matrix[i][j].deleteColor();
					else grid.matrix[i][j].setColor(ball.color); } }

			this.score = savedGame.score - Math.ceil((++undoNumbers - 3)/5);
			board.displayScore(this.score);
			this.ballsNumber = savedGame.ballsNumber;
			if (this.mode == "toplace") {
				grid.oldBall.unselect();
				 this.switchMode("toselect");}
       //puts old nextBalls in order to avoid cheating
      for (var k = 0; k < 3; k++) 
		 nextGrid.matrix[k].setColor(savedGame.nextBalls[k].color); }

	// beginning of game settings
	if (l !== undefined) {
		level = l;
		grid = new Grid(level)
		board.draw(level); }
	else 
		grid.reinitialize();

	var savedGame = new Object;
   this.ballsNumber = 0;
   this.score = 0
   var undoNumbers = 0;
   var ended = false;

	board.displayScore(this.score);
	board.blockMoveMenu(false);
	nextGrid.defineBalls();
	this.switchMode("toselect");
	this.endTurn();

}
