const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

const MAXSCORENUMBERS = 10;
const LEVELNAME = new Array("easy", "normal", "hard");

const currentLevel = window.arguments[0];
const currentScore = window.arguments[1];

Node.prototype.setAttributes = function (list) {
	for (var attr in list)
		this.setAttributeNS(null, attr, list[attr]) }

const prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.{616f2aa8-9674-4009-90de-94ce4ea9d29a}.");

var scoreMatrix = new Array(new Array(), new Array(), new Array());
var newEntry;
var newListItem;
var saveOkButton;

	generateTabpanels();
	extractTable();
	if (currentScore !== undefined) insertScore(scoreMatrix[currentLevel],currentScore);
	createTabs(scoreMatrix);
window.onload = function () {
	if (newEntry) {
		document.getElementById("hsclines-new-textbox").focus();
		document.getElementById("hsclines-new-textbox").select(); }
}

window.onunload = function () {
   if (newEntry) {
		var str = Components.classes["@mozilla.org/supports-string;1"]
					.createInstance(Components.interfaces.nsISupportsString); // need this to save UTF-8 names
		str.data = newEntry.name;
		prefs.setComplexValue("hsname", Components.interfaces.nsISupportsString, str);
		save(scoreMatrix); }
}

function generateTabpanels() {	// generate normal and hard tabpanel by cloning easy tabpanel
	var el=document.getElementById("hsclines-tabpanel-template").cloneNode(true);	// normal
	el.removeAttributeNS(null, "id");
	el.firstChild.setAttributeNS(null, "id", "hsclines-listbox-normal");
	document.getElementById("hsclines-tabpanels").appendChild(el);
	el=document.getElementById("hsclines-tabpanel-template").cloneNode(true);		// hard
	el.removeAttributeNS(null, "id");
	el.firstChild.setAttributeNS(null, "id", "hsclines-listbox-hard");
	document.getElementById("hsclines-tabpanels").appendChild(el); }

function extractTable() {
   var file = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties).get("UChrm", Components.interfaces.nsIFile);
   try { file.append("clines-highscores.txt"); } catch(e) { return; }
   var inputStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);

   try { inputStream.init(file, 0x01, 0444, 0); } catch (e) { return; } //may be the file doesn't exist yet
   inputStream.QueryInterface(Components.interfaces.nsILineInputStream);

	// code to read UTF-8 characters copied from
	// http://developer.mozilla.org/en/docs/Reading_textual_data
	var charset =  "UTF-8";
	var is = Components.classes["@mozilla.org/intl/converter-input-stream;1"]
	                   .createInstance(Components.interfaces.nsIConverterInputStream);
							 is.init(inputStream, charset, 1024, 0xFFFD);
							 
   var levelSplitterRegExp = new RegExp("^\#(\\d)\#$");
   var lineSplitterRegExp = new RegExp("^(\\d\{1,2\})\.~(.*)~(\\d\+)~(\\d\{13\})$");

	if (is instanceof Components.interfaces.nsIUnicharLineInputStream) {
		var line = {};
		var scorearray = {};
		while (is.readLine(line)) {
			if (levelSplitterRegExp.test(line.value)) 
		 scorearray = scoreMatrix[RegExp.$1];
			if (lineSplitterRegExp.test(line.value)) 
		 scorearray[RegExp.$1 - 1] = new Entry(RegExp.$2,RegExp.$3,RegExp.$4); }

		inputStream.close(); }

	is.close(); }

function Entry (name, score, date, level, rank) {
   this.name=name;
   this.score=score;
   this.date=date;
   this.level=level;
   this.rank=rank;
}

function insertScore(matrix, score) {

   var today = new Date();

   for (var i in matrix) {
      if (score > matrix[i].score) {
			 newEntry = new Entry("",score,Date.parse(today),currentLevel,i);
			 matrix.splice(i,0, newEntry);
			 if (matrix.length > MAXSCORENUMBERS)
				 matrix.pop();
			 return; } }

   if (matrix.length < MAXSCORENUMBERS) {	// appending at last place
      newEntry = new Entry("",score,Date.parse(today),currentLevel,matrix.length);
      matrix.push(newEntry); }

}

function createTabs(matrix) {
   var container;
   for (var level in matrix) {
      container = document.getElementById("hsclines-listbox-"+LEVELNAME[level]);
      for (var rank in matrix[level]) {
			 var entry=matrix[level][rank];
			 var el_listitem = document.createElementNS(XUL_NS, "listitem");
			 el_listitem.appendChild(createListCell(parseInt(rank) + 1));
				
			 try { // maybe newEntry doesn't exist
				 if (newEntry.level == level && newEntry.rank == rank) {//creates the textbox for the new score entry
					 el_listitem.appendChild(createTextBox());
					 newListItem = el_listitem;
					 newListItem.className="newListItem";
					 ChangeButton();
				 } else {
					 throw 1;
				 }
				 } catch (e) {
					 el_listitem.appendChild(createListCell(entry.name));
				 } 

		 el_listitem.appendChild(createListCell(entry.score));
		 el_listitem.appendChild(createListCell(FormatDate(entry.date)));
		 container.appendChild(el_listitem); }
   }
   document.getElementById("hsclines-tabbox").selectedIndex=currentLevel;
}

function ChangeButton () {
   var container = document.getElementById("hsclines-bottom-buttons");
   saveOkButton = document.getElementById("hsclines-ok-button");
   var el = document.createElementNS(XUL_NS, "button");

   el.setAttributes( {	"label"	:	document.getElementById("hsclines-strings").getString("validate-button"),
   							"id" 		: 	"hsclines-validate-button",
   							"flex"	:	"1",
   							"command": "hsclines-validate" });

   container.replaceChild(el,saveOkButton);
}

function validate() {
   newNameEntry(document.getElementById("hsclines-new-textbox"),newEntry);
   var container = document.getElementById("hsclines-bottom-buttons");
   container.replaceChild(saveOkButton,document.getElementById("hsclines-validate-button"));
   saveOkButton.focus();
}

function FormatDate(string) {
   var date = new Date();
   date.setTime(string);

   var day = date.getDate()+'';
   var month = date.getMonth() + 1+ '';
   var year = date.getYear() - 100 + '';

   day = TwoDigitsFormat(day);
   month = TwoDigitsFormat(month);
   year = TwoDigitsFormat(year);

   var displayDate = document.getElementById("hsclines-strings").getString("display-date");
   displayDate = displayDate.replace(/day/,day);
   displayDate = displayDate.replace(/month/,month);
   displayDate = displayDate.replace(/year/,year);

   return displayDate; }

function TwoDigitsFormat (string) {
   if (string.length == 1)
      string = '0' + string;
   return string; }

function createListCell (label) {
   var el=document.createElementNS(XUL_NS, "listcell");
   el.setAttributeNS(null, "label", label);
   return el; }

function createTextBox () {

   var el=document.createElementNS(XUL_NS, "textbox");
   el.setAttributes( { "id"			:	"hsclines-new-textbox",
								"maxlength"	:	"12",
								"size"		:	"16",
								"value"		:	prefs.getComplexValue("hsname", Components.interfaces.nsISupportsString).data });
   return el;
}

function newNameEntry (textbox,Entry) {
   scoreMatrix[Entry.level][Entry.rank].name=textbox.value;
   var el = document.createElementNS(XUL_NS, "listcell");
   el.setAttributeNS(null, "label",textbox.value);
   newListItem.replaceChild(el,textbox); }

function save(Matrix) {
   var file = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties).get("UChrm", Components.interfaces.nsIFile);
   if (!file.exists()) {
       file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0755);
   }
   file.append("clines-highscores.txt");
   var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
   outputStream.init(file, 0x02 | 0x08 | 0x20 , 0644, 0);

	var charset = "UTF-8"; // Can be any character encoding name that Mozilla supports


	// code to save UTF-8 characters copied from
	// http://developer.mozilla.org/en/docs/Writing_textual_data
	var os = Components.classes["@mozilla.org/intl/converter-output-stream;1"]
							 .createInstance(Components.interfaces.nsIConverterOutputStream);

    os.init(outputStream, charset, 0, Components.interfaces.nsIConverterInputStream.DEFAULT_REPLACEMENT_CHARACTER);

   var heading = document.getElementById("hsclines-strings").getString("highscores-file-heading");
   os.writeString(heading,heading.length);

   for (var level in Matrix){
      var level_delimiter = '\n#'+level+'#\n';
      os.writeString(level_delimiter,level_delimiter.length);
      for (var j in Matrix[level]) {
			 var entry = Matrix[level][j];
			 var line = parseInt(j)+1+'.~'+entry.name+'~'+entry.score+'~'+entry.date+'\n';
			 os.writeString(line,line.length); } }

	os.writeString('\n',1);
	os.close(); 
    }

function resetScores() {
   try {document.getElementById("hsclines-bottom-buttons").replaceChild(saveOkButton,document.getElementById("hsclines-validate-button"));} catch (e) {}	// in case we are waiting for a name to be entered
   scoreMatrix = new Array(new Array(),new Array(),new Array());
   var container;
   for (var level in scoreMatrix) {
      container = document.getElementById("hsclines-listbox-"+LEVELNAME[level]);
      var list=container.getElementsByTagName("listitem");
      var length = list.length;
      for (var i = 1; i <= length; i++) 
		container.removeChild(list[length - i]); }

   save (scoreMatrix);
}
